/// This code was generated by
/// \ / _    _  _|   _  _
///  | (_)\/(_)(_|\/| |(/_  v1.0.0
///       /       /

using System;
using System.Collections.Generic;
using Twilio.Base;
using Twilio.Converters;

namespace Twilio.Rest.Api.V2010.Account.Recording
{

    /// <summary>
    /// FetchTranscriptionOptions
    /// </summary>
    public class FetchTranscriptionOptions : IOptions<TranscriptionResource>
    {
        /// <summary>
        /// The SID of the Account that created the resource to fetch
        /// </summary>
        public string PathAccountSid { get; set; }
        /// <summary>
        /// The SID of the recording that created the transcriptions to fetch
        /// </summary>
        public string PathRecordingSid { get; }
        /// <summary>
        /// The unique string that identifies the resource
        /// </summary>
        public string PathSid { get; }

        /// <summary>
        /// Construct a new FetchTranscriptionOptions
        /// </summary>
        /// <param name="pathRecordingSid"> The SID of the recording that created the transcriptions to fetch </param>
        /// <param name="pathSid"> The unique string that identifies the resource </param>
        public FetchTranscriptionOptions(string pathRecordingSid, string pathSid)
        {
            PathRecordingSid = pathRecordingSid;
            PathSid = pathSid;
        }

        /// <summary>
        /// Generate the necessary parameters
        /// </summary>
        public List<KeyValuePair<string, string>> GetParams()
        {
            var p = new List<KeyValuePair<string, string>>();
            return p;
        }
    }

    /// <summary>
    /// DeleteTranscriptionOptions
    /// </summary>
    public class DeleteTranscriptionOptions : IOptions<TranscriptionResource>
    {
        /// <summary>
        /// The SID of the Account that created the resources to delete
        /// </summary>
        public string PathAccountSid { get; set; }
        /// <summary>
        /// The SID of the recording that created the transcription to delete
        /// </summary>
        public string PathRecordingSid { get; }
        /// <summary>
        /// The unique string that identifies the resource
        /// </summary>
        public string PathSid { get; }

        /// <summary>
        /// Construct a new DeleteTranscriptionOptions
        /// </summary>
        /// <param name="pathRecordingSid"> The SID of the recording that created the transcription to delete </param>
        /// <param name="pathSid"> The unique string that identifies the resource </param>
        public DeleteTranscriptionOptions(string pathRecordingSid, string pathSid)
        {
            PathRecordingSid = pathRecordingSid;
            PathSid = pathSid;
        }

        /// <summary>
        /// Generate the necessary parameters
        /// </summary>
        public List<KeyValuePair<string, string>> GetParams()
        {
            var p = new List<KeyValuePair<string, string>>();
            return p;
        }
    }

    /// <summary>
    /// ReadTranscriptionOptions
    /// </summary>
    public class ReadTranscriptionOptions : ReadOptions<TranscriptionResource>
    {
        /// <summary>
        /// The SID of the Account that created the resources to read
        /// </summary>
        public string PathAccountSid { get; set; }
        /// <summary>
        /// The SID of the recording that created the transcriptions to read
        /// </summary>
        public string PathRecordingSid { get; }

        /// <summary>
        /// Construct a new ReadTranscriptionOptions
        /// </summary>
        /// <param name="pathRecordingSid"> The SID of the recording that created the transcriptions to read </param>
        public ReadTranscriptionOptions(string pathRecordingSid)
        {
            PathRecordingSid = pathRecordingSid;
        }

        /// <summary>
        /// Generate the necessary parameters
        /// </summary>
        public override List<KeyValuePair<string, string>> GetParams()
        {
            var p = new List<KeyValuePair<string, string>>();
            if (PageSize != null)
            {
                p.Add(new KeyValuePair<string, string>("PageSize", PageSize.ToString()));
            }

            return p;
        }
    }

}