/// This code was generated by
/// \ / _    _  _|   _  _
///  | (_)\/(_)(_|\/| |(/_  v1.0.0
///       /       /
/// <summary>
/// PLEASE NOTE that this class contains preview products that are subject to change. Use them with caution. If you
/// currently do not have developer preview access, please contact help@twilio.com.
///
/// SinkTestResource
/// </summary>

using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using Twilio.Base;
using Twilio.Clients;
using Twilio.Converters;
using Twilio.Exceptions;
using Twilio.Http;

namespace Twilio.Rest.Events.V1.Sink
{

    public class SinkTestResource : Resource
    {
        private static Request BuildCreateRequest(CreateSinkTestOptions options, ITwilioRestClient client)
        {
            return new Request(
                HttpMethod.Post,
                Rest.Domain.Events,
                "/v1/Sinks/" + options.PathSid + "/Test",
                postParams: options.GetParams(),
                headerParams: null
            );
        }

        /// <summary>
        /// Create a new Sink Test Event for the given Sink.
        /// </summary>
        /// <param name="options"> Create SinkTest parameters </param>
        /// <param name="client"> Client to make requests to Twilio </param>
        /// <returns> A single instance of SinkTest </returns>
        public static SinkTestResource Create(CreateSinkTestOptions options, ITwilioRestClient client = null)
        {
            client = client ?? TwilioClient.GetRestClient();
            var response = client.Request(BuildCreateRequest(options, client));
            return FromJson(response.Content);
        }

        #if !NET35
        /// <summary>
        /// Create a new Sink Test Event for the given Sink.
        /// </summary>
        /// <param name="options"> Create SinkTest parameters </param>
        /// <param name="client"> Client to make requests to Twilio </param>
        /// <returns> Task that resolves to A single instance of SinkTest </returns>
        public static async System.Threading.Tasks.Task<SinkTestResource> CreateAsync(CreateSinkTestOptions options,
                                                                                      ITwilioRestClient client = null)
        {
            client = client ?? TwilioClient.GetRestClient();
            var response = await client.RequestAsync(BuildCreateRequest(options, client));
            return FromJson(response.Content);
        }
        #endif

        /// <summary>
        /// Create a new Sink Test Event for the given Sink.
        /// </summary>
        /// <param name="pathSid"> A string that uniquely identifies the Sink to be Tested. </param>
        /// <param name="client"> Client to make requests to Twilio </param>
        /// <returns> A single instance of SinkTest </returns>
        public static SinkTestResource Create(string pathSid, ITwilioRestClient client = null)
        {
            var options = new CreateSinkTestOptions(pathSid);
            return Create(options, client);
        }

        #if !NET35
        /// <summary>
        /// Create a new Sink Test Event for the given Sink.
        /// </summary>
        /// <param name="pathSid"> A string that uniquely identifies the Sink to be Tested. </param>
        /// <param name="client"> Client to make requests to Twilio </param>
        /// <returns> Task that resolves to A single instance of SinkTest </returns>
        public static async System.Threading.Tasks.Task<SinkTestResource> CreateAsync(string pathSid,
                                                                                      ITwilioRestClient client = null)
        {
            var options = new CreateSinkTestOptions(pathSid);
            return await CreateAsync(options, client);
        }
        #endif

        /// <summary>
        /// Converts a JSON string into a SinkTestResource object
        /// </summary>
        /// <param name="json"> Raw JSON string </param>
        /// <returns> SinkTestResource object represented by the provided JSON </returns>
        public static SinkTestResource FromJson(string json)
        {
            // Convert all checked exceptions to Runtime
            try
            {
                return JsonConvert.DeserializeObject<SinkTestResource>(json);
            }
            catch (JsonException e)
            {
                throw new ApiException(e.Message, e);
            }
        }

        /// <summary>
        /// Feedback indicating whether the test event was generated.
        /// </summary>
        [JsonProperty("result")]
        public string Result { get; private set; }

        private SinkTestResource()
        {

        }
    }

}