/// This code was generated by
/// \ / _    _  _|   _  _
///  | (_)\/(_)(_|\/| |(/_  v1.0.0
///       /       /

using System;
using System.Collections.Generic;
using Twilio.Base;
using Twilio.Converters;

namespace Twilio.Rest.FlexApi.V1
{

    /// <summary>
    /// ReadChannelOptions
    /// </summary>
    public class ReadChannelOptions : ReadOptions<ChannelResource>
    {
        /// <summary>
        /// Generate the necessary parameters
        /// </summary>
        public override List<KeyValuePair<string, string>> GetParams()
        {
            var p = new List<KeyValuePair<string, string>>();
            if (PageSize != null)
            {
                p.Add(new KeyValuePair<string, string>("PageSize", PageSize.ToString()));
            }

            return p;
        }
    }

    /// <summary>
    /// FetchChannelOptions
    /// </summary>
    public class FetchChannelOptions : IOptions<ChannelResource>
    {
        /// <summary>
        /// The SID that identifies the Flex chat channel resource to fetch
        /// </summary>
        public string PathSid { get; }

        /// <summary>
        /// Construct a new FetchChannelOptions
        /// </summary>
        /// <param name="pathSid"> The SID that identifies the Flex chat channel resource to fetch </param>
        public FetchChannelOptions(string pathSid)
        {
            PathSid = pathSid;
        }

        /// <summary>
        /// Generate the necessary parameters
        /// </summary>
        public List<KeyValuePair<string, string>> GetParams()
        {
            var p = new List<KeyValuePair<string, string>>();
            return p;
        }
    }

    /// <summary>
    /// CreateChannelOptions
    /// </summary>
    public class CreateChannelOptions : IOptions<ChannelResource>
    {
        /// <summary>
        /// The SID of the FlexFlow
        /// </summary>
        public string FlexFlowSid { get; }
        /// <summary>
        /// The identity value that identifies the new resource's chat User
        /// </summary>
        public string Identity { get; }
        /// <summary>
        /// The chat participant's friendly name
        /// </summary>
        public string ChatUserFriendlyName { get; }
        /// <summary>
        /// The chat channel's friendly name
        /// </summary>
        public string ChatFriendlyName { get; }
        /// <summary>
        /// The Target Contact Identity
        /// </summary>
        public string Target { get; set; }
        /// <summary>
        /// The chat channel's unique name
        /// </summary>
        public string ChatUniqueName { get; set; }
        /// <summary>
        /// The pre-engagement data
        /// </summary>
        public string PreEngagementData { get; set; }
        /// <summary>
        /// The SID of the TaskRouter task
        /// </summary>
        public string TaskSid { get; set; }
        /// <summary>
        /// The task attributes to be added for the TaskRouter Task
        /// </summary>
        public string TaskAttributes { get; set; }
        /// <summary>
        /// Whether to create the channel as long-lived
        /// </summary>
        public bool? LongLived { get; set; }

        /// <summary>
        /// Construct a new CreateChannelOptions
        /// </summary>
        /// <param name="flexFlowSid"> The SID of the FlexFlow </param>
        /// <param name="identity"> The identity value that identifies the new resource's chat User </param>
        /// <param name="chatUserFriendlyName"> The chat participant's friendly name </param>
        /// <param name="chatFriendlyName"> The chat channel's friendly name </param>
        public CreateChannelOptions(string flexFlowSid,
                                    string identity,
                                    string chatUserFriendlyName,
                                    string chatFriendlyName)
        {
            FlexFlowSid = flexFlowSid;
            Identity = identity;
            ChatUserFriendlyName = chatUserFriendlyName;
            ChatFriendlyName = chatFriendlyName;
        }

        /// <summary>
        /// Generate the necessary parameters
        /// </summary>
        public List<KeyValuePair<string, string>> GetParams()
        {
            var p = new List<KeyValuePair<string, string>>();
            if (FlexFlowSid != null)
            {
                p.Add(new KeyValuePair<string, string>("FlexFlowSid", FlexFlowSid.ToString()));
            }

            if (Identity != null)
            {
                p.Add(new KeyValuePair<string, string>("Identity", Identity));
            }

            if (ChatUserFriendlyName != null)
            {
                p.Add(new KeyValuePair<string, string>("ChatUserFriendlyName", ChatUserFriendlyName));
            }

            if (ChatFriendlyName != null)
            {
                p.Add(new KeyValuePair<string, string>("ChatFriendlyName", ChatFriendlyName));
            }

            if (Target != null)
            {
                p.Add(new KeyValuePair<string, string>("Target", Target));
            }

            if (ChatUniqueName != null)
            {
                p.Add(new KeyValuePair<string, string>("ChatUniqueName", ChatUniqueName));
            }

            if (PreEngagementData != null)
            {
                p.Add(new KeyValuePair<string, string>("PreEngagementData", PreEngagementData));
            }

            if (TaskSid != null)
            {
                p.Add(new KeyValuePair<string, string>("TaskSid", TaskSid.ToString()));
            }

            if (TaskAttributes != null)
            {
                p.Add(new KeyValuePair<string, string>("TaskAttributes", TaskAttributes));
            }

            if (LongLived != null)
            {
                p.Add(new KeyValuePair<string, string>("LongLived", LongLived.Value.ToString().ToLower()));
            }

            return p;
        }
    }

    /// <summary>
    /// DeleteChannelOptions
    /// </summary>
    public class DeleteChannelOptions : IOptions<ChannelResource>
    {
        /// <summary>
        /// The SID of the Flex chat channel resource to delete
        /// </summary>
        public string PathSid { get; }

        /// <summary>
        /// Construct a new DeleteChannelOptions
        /// </summary>
        /// <param name="pathSid"> The SID of the Flex chat channel resource to delete </param>
        public DeleteChannelOptions(string pathSid)
        {
            PathSid = pathSid;
        }

        /// <summary>
        /// Generate the necessary parameters
        /// </summary>
        public List<KeyValuePair<string, string>> GetParams()
        {
            var p = new List<KeyValuePair<string, string>>();
            return p;
        }
    }

}