/// This code was generated by
/// \ / _    _  _|   _  _
///  | (_)\/(_)(_|\/| |(/_  v1.0.0
///       /       /

using System;
using System.Collections.Generic;
using Twilio.Base;
using Twilio.Converters;

namespace Twilio.Rest.Numbers.V2.RegulatoryCompliance.Bundle
{

    /// <summary>
    /// CreateEvaluationOptions
    /// </summary>
    public class CreateEvaluationOptions : IOptions<EvaluationResource>
    {
        /// <summary>
        /// The bundle_sid
        /// </summary>
        public string PathBundleSid { get; }

        /// <summary>
        /// Construct a new CreateEvaluationOptions
        /// </summary>
        /// <param name="pathBundleSid"> The bundle_sid </param>
        public CreateEvaluationOptions(string pathBundleSid)
        {
            PathBundleSid = pathBundleSid;
        }

        /// <summary>
        /// Generate the necessary parameters
        /// </summary>
        public List<KeyValuePair<string, string>> GetParams()
        {
            var p = new List<KeyValuePair<string, string>>();
            return p;
        }
    }

    /// <summary>
    /// Retrieve a list of Evaluations associated to the Bundle resource.
    /// </summary>
    public class ReadEvaluationOptions : ReadOptions<EvaluationResource>
    {
        /// <summary>
        /// The bundle_sid
        /// </summary>
        public string PathBundleSid { get; }

        /// <summary>
        /// Construct a new ReadEvaluationOptions
        /// </summary>
        /// <param name="pathBundleSid"> The bundle_sid </param>
        public ReadEvaluationOptions(string pathBundleSid)
        {
            PathBundleSid = pathBundleSid;
        }

        /// <summary>
        /// Generate the necessary parameters
        /// </summary>
        public override List<KeyValuePair<string, string>> GetParams()
        {
            var p = new List<KeyValuePair<string, string>>();
            if (PageSize != null)
            {
                p.Add(new KeyValuePair<string, string>("PageSize", PageSize.ToString()));
            }

            return p;
        }
    }

    /// <summary>
    /// Fetch specific Evaluation Instance.
    /// </summary>
    public class FetchEvaluationOptions : IOptions<EvaluationResource>
    {
        /// <summary>
        /// The unique string that identifies the resource
        /// </summary>
        public string PathBundleSid { get; }
        /// <summary>
        /// The unique string that identifies the Evaluation resource
        /// </summary>
        public string PathSid { get; }

        /// <summary>
        /// Construct a new FetchEvaluationOptions
        /// </summary>
        /// <param name="pathBundleSid"> The unique string that identifies the resource </param>
        /// <param name="pathSid"> The unique string that identifies the Evaluation resource </param>
        public FetchEvaluationOptions(string pathBundleSid, string pathSid)
        {
            PathBundleSid = pathBundleSid;
            PathSid = pathSid;
        }

        /// <summary>
        /// Generate the necessary parameters
        /// </summary>
        public List<KeyValuePair<string, string>> GetParams()
        {
            var p = new List<KeyValuePair<string, string>>();
            return p;
        }
    }

}