/// This code was generated by
/// \ / _    _  _|   _  _
///  | (_)\/(_)(_|\/| |(/_  v1.0.0
///       /       /
/// <summary>
/// SupportingDocumentTypeResource
/// </summary>

using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using Twilio.Base;
using Twilio.Clients;
using Twilio.Converters;
using Twilio.Exceptions;
using Twilio.Http;

namespace Twilio.Rest.Numbers.V2.RegulatoryCompliance
{

    public class SupportingDocumentTypeResource : Resource
    {
        private static Request BuildReadRequest(ReadSupportingDocumentTypeOptions options, ITwilioRestClient client)
        {
            return new Request(
                HttpMethod.Get,
                Rest.Domain.Numbers,
                "/v2/RegulatoryCompliance/SupportingDocumentTypes",
                queryParams: options.GetParams(),
                headerParams: null
            );
        }

        /// <summary>
        /// Retrieve a list of all Supporting Document Types.
        /// </summary>
        /// <param name="options"> Read SupportingDocumentType parameters </param>
        /// <param name="client"> Client to make requests to Twilio </param>
        /// <returns> A single instance of SupportingDocumentType </returns>
        public static ResourceSet<SupportingDocumentTypeResource> Read(ReadSupportingDocumentTypeOptions options,
                                                                       ITwilioRestClient client = null)
        {
            client = client ?? TwilioClient.GetRestClient();
            var response = client.Request(BuildReadRequest(options, client));

            var page = Page<SupportingDocumentTypeResource>.FromJson("supporting_document_types", response.Content);
            return new ResourceSet<SupportingDocumentTypeResource>(page, options, client);
        }

        #if !NET35
        /// <summary>
        /// Retrieve a list of all Supporting Document Types.
        /// </summary>
        /// <param name="options"> Read SupportingDocumentType parameters </param>
        /// <param name="client"> Client to make requests to Twilio </param>
        /// <returns> Task that resolves to A single instance of SupportingDocumentType </returns>
        public static async System.Threading.Tasks.Task<ResourceSet<SupportingDocumentTypeResource>> ReadAsync(ReadSupportingDocumentTypeOptions options,
                                                                                                               ITwilioRestClient client = null)
        {
            client = client ?? TwilioClient.GetRestClient();
            var response = await client.RequestAsync(BuildReadRequest(options, client));

            var page = Page<SupportingDocumentTypeResource>.FromJson("supporting_document_types", response.Content);
            return new ResourceSet<SupportingDocumentTypeResource>(page, options, client);
        }
        #endif

        /// <summary>
        /// Retrieve a list of all Supporting Document Types.
        /// </summary>
        /// <param name="pageSize"> Page size </param>
        /// <param name="limit"> Record limit </param>
        /// <param name="client"> Client to make requests to Twilio </param>
        /// <returns> A single instance of SupportingDocumentType </returns>
        public static ResourceSet<SupportingDocumentTypeResource> Read(int? pageSize = null,
                                                                       long? limit = null,
                                                                       ITwilioRestClient client = null)
        {
            var options = new ReadSupportingDocumentTypeOptions(){PageSize = pageSize, Limit = limit};
            return Read(options, client);
        }

        #if !NET35
        /// <summary>
        /// Retrieve a list of all Supporting Document Types.
        /// </summary>
        /// <param name="pageSize"> Page size </param>
        /// <param name="limit"> Record limit </param>
        /// <param name="client"> Client to make requests to Twilio </param>
        /// <returns> Task that resolves to A single instance of SupportingDocumentType </returns>
        public static async System.Threading.Tasks.Task<ResourceSet<SupportingDocumentTypeResource>> ReadAsync(int? pageSize = null,
                                                                                                               long? limit = null,
                                                                                                               ITwilioRestClient client = null)
        {
            var options = new ReadSupportingDocumentTypeOptions(){PageSize = pageSize, Limit = limit};
            return await ReadAsync(options, client);
        }
        #endif

        /// <summary>
        /// Fetch the target page of records
        /// </summary>
        /// <param name="targetUrl"> API-generated URL for the requested results page </param>
        /// <param name="client"> Client to make requests to Twilio </param>
        /// <returns> The target page of records </returns>
        public static Page<SupportingDocumentTypeResource> GetPage(string targetUrl, ITwilioRestClient client)
        {
            client = client ?? TwilioClient.GetRestClient();

            var request = new Request(
                HttpMethod.Get,
                targetUrl
            );

            var response = client.Request(request);
            return Page<SupportingDocumentTypeResource>.FromJson("supporting_document_types", response.Content);
        }

        /// <summary>
        /// Fetch the next page of records
        /// </summary>
        /// <param name="page"> current page of records </param>
        /// <param name="client"> Client to make requests to Twilio </param>
        /// <returns> The next page of records </returns>
        public static Page<SupportingDocumentTypeResource> NextPage(Page<SupportingDocumentTypeResource> page,
                                                                    ITwilioRestClient client)
        {
            var request = new Request(
                HttpMethod.Get,
                page.GetNextPageUrl(Rest.Domain.Numbers)
            );

            var response = client.Request(request);
            return Page<SupportingDocumentTypeResource>.FromJson("supporting_document_types", response.Content);
        }

        /// <summary>
        /// Fetch the previous page of records
        /// </summary>
        /// <param name="page"> current page of records </param>
        /// <param name="client"> Client to make requests to Twilio </param>
        /// <returns> The previous page of records </returns>
        public static Page<SupportingDocumentTypeResource> PreviousPage(Page<SupportingDocumentTypeResource> page,
                                                                        ITwilioRestClient client)
        {
            var request = new Request(
                HttpMethod.Get,
                page.GetPreviousPageUrl(Rest.Domain.Numbers)
            );

            var response = client.Request(request);
            return Page<SupportingDocumentTypeResource>.FromJson("supporting_document_types", response.Content);
        }

        private static Request BuildFetchRequest(FetchSupportingDocumentTypeOptions options, ITwilioRestClient client)
        {
            return new Request(
                HttpMethod.Get,
                Rest.Domain.Numbers,
                "/v2/RegulatoryCompliance/SupportingDocumentTypes/" + options.PathSid + "",
                queryParams: options.GetParams(),
                headerParams: null
            );
        }

        /// <summary>
        /// Fetch a specific Supporting Document Type Instance.
        /// </summary>
        /// <param name="options"> Fetch SupportingDocumentType parameters </param>
        /// <param name="client"> Client to make requests to Twilio </param>
        /// <returns> A single instance of SupportingDocumentType </returns>
        public static SupportingDocumentTypeResource Fetch(FetchSupportingDocumentTypeOptions options,
                                                           ITwilioRestClient client = null)
        {
            client = client ?? TwilioClient.GetRestClient();
            var response = client.Request(BuildFetchRequest(options, client));
            return FromJson(response.Content);
        }

        #if !NET35
        /// <summary>
        /// Fetch a specific Supporting Document Type Instance.
        /// </summary>
        /// <param name="options"> Fetch SupportingDocumentType parameters </param>
        /// <param name="client"> Client to make requests to Twilio </param>
        /// <returns> Task that resolves to A single instance of SupportingDocumentType </returns>
        public static async System.Threading.Tasks.Task<SupportingDocumentTypeResource> FetchAsync(FetchSupportingDocumentTypeOptions options,
                                                                                                   ITwilioRestClient client = null)
        {
            client = client ?? TwilioClient.GetRestClient();
            var response = await client.RequestAsync(BuildFetchRequest(options, client));
            return FromJson(response.Content);
        }
        #endif

        /// <summary>
        /// Fetch a specific Supporting Document Type Instance.
        /// </summary>
        /// <param name="pathSid"> The unique string that identifies the Supporting Document Type resource </param>
        /// <param name="client"> Client to make requests to Twilio </param>
        /// <returns> A single instance of SupportingDocumentType </returns>
        public static SupportingDocumentTypeResource Fetch(string pathSid, ITwilioRestClient client = null)
        {
            var options = new FetchSupportingDocumentTypeOptions(pathSid);
            return Fetch(options, client);
        }

        #if !NET35
        /// <summary>
        /// Fetch a specific Supporting Document Type Instance.
        /// </summary>
        /// <param name="pathSid"> The unique string that identifies the Supporting Document Type resource </param>
        /// <param name="client"> Client to make requests to Twilio </param>
        /// <returns> Task that resolves to A single instance of SupportingDocumentType </returns>
        public static async System.Threading.Tasks.Task<SupportingDocumentTypeResource> FetchAsync(string pathSid,
                                                                                                   ITwilioRestClient client = null)
        {
            var options = new FetchSupportingDocumentTypeOptions(pathSid);
            return await FetchAsync(options, client);
        }
        #endif

        /// <summary>
        /// Converts a JSON string into a SupportingDocumentTypeResource object
        /// </summary>
        /// <param name="json"> Raw JSON string </param>
        /// <returns> SupportingDocumentTypeResource object represented by the provided JSON </returns>
        public static SupportingDocumentTypeResource FromJson(string json)
        {
            // Convert all checked exceptions to Runtime
            try
            {
                return JsonConvert.DeserializeObject<SupportingDocumentTypeResource>(json);
            }
            catch (JsonException e)
            {
                throw new ApiException(e.Message, e);
            }
        }

        /// <summary>
        /// The unique string that identifies the Supporting Document Type resource
        /// </summary>
        [JsonProperty("sid")]
        public string Sid { get; private set; }
        /// <summary>
        /// A human-readable description of the Supporting Document Type resource
        /// </summary>
        [JsonProperty("friendly_name")]
        public string FriendlyName { get; private set; }
        /// <summary>
        /// The machine-readable description of the Supporting Document Type resource
        /// </summary>
        [JsonProperty("machine_name")]
        public string MachineName { get; private set; }
        /// <summary>
        /// The required information for creating a Supporting Document
        /// </summary>
        [JsonProperty("fields")]
        public List<object> Fields { get; private set; }
        /// <summary>
        /// The absolute URL of the Supporting Document Type resource
        /// </summary>
        [JsonProperty("url")]
        public Uri Url { get; private set; }

        private SupportingDocumentTypeResource()
        {

        }
    }

}