/// This code was generated by
/// \ / _    _  _|   _  _
///  | (_)\/(_)(_|\/| |(/_  v1.0.0
///       /       /

using System;
using System.IO;
using System.Text;
using System.Xml.Linq;
using Twilio.Converters;

namespace Twilio.TwiML.Voice
{

    /// <summary>
    /// Sip TwiML Noun used in Refer
    /// </summary>
    public class ReferSip : TwiML
    {
        /// <summary>
        /// SIP URL
        /// </summary>
        public Uri SipUrl { get; set; }

        /// <summary>
        /// Create a new ReferSip
        /// </summary>
        /// <param name="sipUrl"> SIP URL, the body of the TwiML Element. </param>
        public ReferSip(Uri sipUrl = null) : base("Sip")
        {
            this.SipUrl = sipUrl;
        }

        /// <summary>
        /// Return the body of the TwiML tag
        /// </summary>
        protected override string GetElementBody()
        {
            return this.SipUrl != null ? Serializers.Url(this.SipUrl) : string.Empty;
        }

        /// <summary>
        /// Append a child TwiML element to this element returning this element to allow chaining.
        /// </summary>
        /// <param name="childElem"> Child TwiML element to add </param>
        public new ReferSip Append(TwiML childElem)
        {
            return (ReferSip) base.Append(childElem);
        }

        /// <summary>
        /// Add freeform key-value attributes to the generated xml
        /// </summary>
        /// <param name="key"> Option key </param>
        /// <param name="value"> Option value </param>
        public new ReferSip SetOption(string key, object value)
        {
            return (ReferSip) base.SetOption(key, value);
        }
    }

}