/// This code was generated by
/// \ / _    _  _|   _  _
///  | (_)\/(_)(_|\/| |(/_  v1.0.0
///       /       /

using System.IO;
using System.Text;
using System.Xml.Linq;

namespace Twilio.TwiML.Voice
{

    /// <summary>
    /// Adding A Pause Between Sentences in Say
    /// </summary>
    public class SsmlS : TwiML
    {
        /// <summary>
        /// Words to speak
        /// </summary>
        public string Words { get; set; }

        /// <summary>
        /// Create a new SsmlS
        /// </summary>
        /// <param name="words"> Words to speak, the body of the TwiML Element. </param>
        public SsmlS(string words = null) : base("s")
        {
            this.Words = words;
        }

        /// <summary>
        /// Return the body of the TwiML tag
        /// </summary>
        protected override string GetElementBody()
        {
            return this.Words != null ? this.Words : string.Empty;
        }

        /// <summary>
        /// Append a child TwiML element to this element returning this element to allow chaining.
        /// </summary>
        /// <param name="childElem"> Child TwiML element to add </param>
        public new SsmlS Append(TwiML childElem)
        {
            return (SsmlS) base.Append(childElem);
        }

        /// <summary>
        /// Add freeform key-value attributes to the generated xml
        /// </summary>
        /// <param name="key"> Option key </param>
        /// <param name="value"> Option value </param>
        public new SsmlS SetOption(string key, object value)
        {
            return (SsmlS) base.SetOption(key, value);
        }
    }

}