/// This code was generated by
/// \ / _    _  _|   _  _
///  | (_)\/(_)(_|\/| |(/_  v1.0.0
///       /       /

using System.Collections.Generic;
using System.IO;
using System.Text;
using System.Xml.Linq;

namespace Twilio.TwiML.Voice
{

    /// <summary>
    /// Pronouncing Acronyms and Abbreviations in Say
    /// </summary>
    public class SsmlSub : TwiML
    {
        /// <summary>
        /// Words to be substituted
        /// </summary>
        public string Words { get; set; }
        /// <summary>
        /// Substitute a different word (or pronunciation) for selected text such as an acronym or abbreviation
        /// </summary>
        public string Alias { get; set; }

        /// <summary>
        /// Create a new SsmlSub
        /// </summary>
        /// <param name="words"> Words to be substituted, the body of the TwiML Element. </param>
        /// <param name="alias"> Substitute a different word (or pronunciation) for selected text such as an acronym or
        ///             abbreviation </param>
        public SsmlSub(string words = null, string alias = null) : base("sub")
        {
            this.Words = words;
            this.Alias = alias;
        }

        /// <summary>
        /// Return the body of the TwiML tag
        /// </summary>
        protected override string GetElementBody()
        {
            return this.Words != null ? this.Words : string.Empty;
        }

        /// <summary>
        /// Return the attributes of the TwiML tag
        /// </summary>
        protected override List<XAttribute> GetElementAttributes()
        {
            var attributes = new List<XAttribute>();
            if (this.Alias != null)
            {
                attributes.Add(new XAttribute("alias", this.Alias));
            }
            return attributes;
        }

        /// <summary>
        /// Append a child TwiML element to this element returning this element to allow chaining.
        /// </summary>
        /// <param name="childElem"> Child TwiML element to add </param>
        public new SsmlSub Append(TwiML childElem)
        {
            return (SsmlSub) base.Append(childElem);
        }

        /// <summary>
        /// Add freeform key-value attributes to the generated xml
        /// </summary>
        /// <param name="key"> Option key </param>
        /// <param name="value"> Option value </param>
        public new SsmlSub SetOption(string key, object value)
        {
            return (SsmlSub) base.SetOption(key, value);
        }
    }

}