/// This code was generated by
/// \ / _    _  _|   _  _
///  | (_)\/(_)(_|\/| |(/_  v1.0.0
///       /       /

using NSubstitute;
using NSubstitute.ExceptionExtensions;
using NUnit.Framework;
using System;
using System.Collections.Generic;
using Twilio.Clients;
using Twilio.Converters;
using Twilio.Exceptions;
using Twilio.Http;
using Twilio.Rest.Preview.TrustedComms;

namespace Twilio.Tests.Rest.Preview.TrustedComms
{

    [TestFixture]
    public class CurrentCallTest : TwilioTest
    {
        [Test]
        public void TestFetchRequest()
        {
            var twilioRestClient = Substitute.For<ITwilioRestClient>();
            var request = new Request(
                HttpMethod.Get,
                Twilio.Rest.Domain.Preview,
                "/TrustedComms/CurrentCall",
                ""
            );
            request.AddHeaderParam("X-Xcnam-Sensitive-Phone-Number-From", Serialize("x_xcnam_sensitive_phone_number_from"));
            request.AddHeaderParam("X-Xcnam-Sensitive-Phone-Number-To", Serialize("x_xcnam_sensitive_phone_number_to"));
            twilioRestClient.Request(request).Throws(new ApiException("Server Error, no content"));

            try
            {
                CurrentCallResource.Fetch(xXcnamSensitivePhoneNumberFrom: Serialize("x_xcnam_sensitive_phone_number_from"), xXcnamSensitivePhoneNumberTo: Serialize("x_xcnam_sensitive_phone_number_to"), client: twilioRestClient);
                Assert.Fail("Expected TwilioException to be thrown for 500");
            }
            catch (ApiException) {}
            twilioRestClient.Received().Request(request);
        }

        [Test]
        public void TestReadFoundResponse()
        {
            var twilioRestClient = Substitute.For<ITwilioRestClient>();
            twilioRestClient.AccountSid.Returns("ACXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX");
            twilioRestClient.Request(Arg.Any<Request>())
                            .Returns(new Response(
                                         System.Net.HttpStatusCode.OK,
                                         "{\"bg_color\": \"#fff\",\"caller\": \"Owl Bank\",\"created_at\": \"2019-05-01T20:00:00Z\",\"font_color\": \"#f22f46\",\"from\": \"+1500123\",\"logo\": \"https://www.twilio.com/marketing/bundles/company/img/logos/red/twilio-logo-red.png\",\"manager\": \"Twilio\",\"reason\": \"Hello Jhon, your bank appointment has been confirmed.\",\"shield_img\": \"https://www.twilio.com/marketing/bundles/company/img/badges/red/twilio-badge-red.png\",\"sid\": \"CQaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa\",\"status\": \"ringing\",\"to\": \"+1500456\",\"url\": \"https://preview.twilio.com/TrustedComms/CurrentCall\",\"use_case\": \"conversational\"}"
                                     ));

            var response = CurrentCallResource.Fetch(xXcnamSensitivePhoneNumberFrom: Serialize("x_xcnam_sensitive_phone_number_from"), xXcnamSensitivePhoneNumberTo: Serialize("x_xcnam_sensitive_phone_number_to"), client: twilioRestClient);
            Assert.NotNull(response);
        }
    }

}